=begin
#Talon.One API

#The Talon.One API is used to manage applications and campaigns, as well as to integrate with your application. The operations in the _Integration API_ section are used to integrate with our platform, while the other operations are used to manage applications and campaigns.  ### Where is the API?  The API is available at the same hostname as these docs. For example, if you are reading this page at `https://mycompany.talon.one/docs/api/`, the URL for the [updateCustomerProfile][] operation is `https://mycompany.talon.one/v1/customer_profiles/id`  [updateCustomerProfile]: #operation--v1-customer_profiles--integrationId--put 

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module TalonOne
  # 
  class CustomerAnalytics
    # Total accepted coupons for this customer
    attr_accessor :accepted_coupons

    # Total created coupons for this customer
    attr_accessor :created_coupons

    # Total free items given to this customer
    attr_accessor :free_items

    # Total orders made by this customer
    attr_accessor :total_orders

    # Total orders made by this customer that had a discount
    attr_accessor :total_discounted_orders

    # Total Revenue across all closed sessions
    attr_accessor :total_revenue

    # The sum of discounts that were given across all closed sessions
    attr_accessor :total_discounts

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'accepted_coupons' => :'acceptedCoupons',
        :'created_coupons' => :'createdCoupons',
        :'free_items' => :'freeItems',
        :'total_orders' => :'totalOrders',
        :'total_discounted_orders' => :'totalDiscountedOrders',
        :'total_revenue' => :'totalRevenue',
        :'total_discounts' => :'totalDiscounts'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'accepted_coupons' => :'Integer',
        :'created_coupons' => :'Integer',
        :'free_items' => :'Integer',
        :'total_orders' => :'Integer',
        :'total_discounted_orders' => :'Integer',
        :'total_revenue' => :'Float',
        :'total_discounts' => :'Float'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `TalonOne::CustomerAnalytics` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `TalonOne::CustomerAnalytics`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'accepted_coupons')
        self.accepted_coupons = attributes[:'accepted_coupons']
      end

      if attributes.key?(:'created_coupons')
        self.created_coupons = attributes[:'created_coupons']
      end

      if attributes.key?(:'free_items')
        self.free_items = attributes[:'free_items']
      end

      if attributes.key?(:'total_orders')
        self.total_orders = attributes[:'total_orders']
      end

      if attributes.key?(:'total_discounted_orders')
        self.total_discounted_orders = attributes[:'total_discounted_orders']
      end

      if attributes.key?(:'total_revenue')
        self.total_revenue = attributes[:'total_revenue']
      end

      if attributes.key?(:'total_discounts')
        self.total_discounts = attributes[:'total_discounts']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @accepted_coupons.nil?
        invalid_properties.push('invalid value for "accepted_coupons", accepted_coupons cannot be nil.')
      end

      if @created_coupons.nil?
        invalid_properties.push('invalid value for "created_coupons", created_coupons cannot be nil.')
      end

      if @free_items.nil?
        invalid_properties.push('invalid value for "free_items", free_items cannot be nil.')
      end

      if @total_orders.nil?
        invalid_properties.push('invalid value for "total_orders", total_orders cannot be nil.')
      end

      if @total_discounted_orders.nil?
        invalid_properties.push('invalid value for "total_discounted_orders", total_discounted_orders cannot be nil.')
      end

      if @total_revenue.nil?
        invalid_properties.push('invalid value for "total_revenue", total_revenue cannot be nil.')
      end

      if @total_discounts.nil?
        invalid_properties.push('invalid value for "total_discounts", total_discounts cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @accepted_coupons.nil?
      return false if @created_coupons.nil?
      return false if @free_items.nil?
      return false if @total_orders.nil?
      return false if @total_discounted_orders.nil?
      return false if @total_revenue.nil?
      return false if @total_discounts.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          accepted_coupons == o.accepted_coupons &&
          created_coupons == o.created_coupons &&
          free_items == o.free_items &&
          total_orders == o.total_orders &&
          total_discounted_orders == o.total_discounted_orders &&
          total_revenue == o.total_revenue &&
          total_discounts == o.total_discounts
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [accepted_coupons, created_coupons, free_items, total_orders, total_discounted_orders, total_revenue, total_discounts].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        TalonOne.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
