=begin
#Talon.One API

#The Talon.One API is used to manage applications and campaigns, as well as to integrate with your application. The operations in the _Integration API_ section are used to integrate with our platform, while the other operations are used to manage applications and campaigns.  ### Where is the API?  The API is available at the same hostname as these docs. For example, if you are reading this page at `https://mycompany.talon.one/docs/api/`, the URL for the [updateCustomerProfile][] operation is `https://mycompany.talon.one/v1/customer_profiles/id`  [updateCustomerProfile]: #operation--v1-customer_profiles--integrationId--put 

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module TalonOne
  # Contains all entities that might interest Talon.One integrations. This is the response type returned by the V2 PUT customer_session endpoint 
  class IntegrationStateV2
    attr_accessor :customer_session

    attr_accessor :customer_profile

    attr_accessor :event

    attr_accessor :loyalty

    attr_accessor :referral

    attr_accessor :coupons

    attr_accessor :triggered_campaigns

    attr_accessor :effects

    attr_accessor :rule_failure_reasons

    attr_accessor :created_coupons

    attr_accessor :created_referrals

    attr_accessor :awarded_giveaways

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'customer_session' => :'customerSession',
        :'customer_profile' => :'customerProfile',
        :'event' => :'event',
        :'loyalty' => :'loyalty',
        :'referral' => :'referral',
        :'coupons' => :'coupons',
        :'triggered_campaigns' => :'triggeredCampaigns',
        :'effects' => :'effects',
        :'rule_failure_reasons' => :'ruleFailureReasons',
        :'created_coupons' => :'createdCoupons',
        :'created_referrals' => :'createdReferrals',
        :'awarded_giveaways' => :'awardedGiveaways'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'customer_session' => :'CustomerSessionV2',
        :'customer_profile' => :'CustomerProfile',
        :'event' => :'Event',
        :'loyalty' => :'Loyalty',
        :'referral' => :'Referral',
        :'coupons' => :'Array<Coupon>',
        :'triggered_campaigns' => :'Array<Campaign>',
        :'effects' => :'Array<Effect>',
        :'rule_failure_reasons' => :'Array<RuleFailureReason>',
        :'created_coupons' => :'Array<Coupon>',
        :'created_referrals' => :'Array<Referral>',
        :'awarded_giveaways' => :'Array<Giveaway>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `TalonOne::IntegrationStateV2` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `TalonOne::IntegrationStateV2`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'customer_session')
        self.customer_session = attributes[:'customer_session']
      end

      if attributes.key?(:'customer_profile')
        self.customer_profile = attributes[:'customer_profile']
      end

      if attributes.key?(:'event')
        self.event = attributes[:'event']
      end

      if attributes.key?(:'loyalty')
        self.loyalty = attributes[:'loyalty']
      end

      if attributes.key?(:'referral')
        self.referral = attributes[:'referral']
      end

      if attributes.key?(:'coupons')
        if (value = attributes[:'coupons']).is_a?(Array)
          self.coupons = value
        end
      end

      if attributes.key?(:'triggered_campaigns')
        if (value = attributes[:'triggered_campaigns']).is_a?(Array)
          self.triggered_campaigns = value
        end
      end

      if attributes.key?(:'effects')
        if (value = attributes[:'effects']).is_a?(Array)
          self.effects = value
        end
      end

      if attributes.key?(:'rule_failure_reasons')
        if (value = attributes[:'rule_failure_reasons']).is_a?(Array)
          self.rule_failure_reasons = value
        end
      end

      if attributes.key?(:'created_coupons')
        if (value = attributes[:'created_coupons']).is_a?(Array)
          self.created_coupons = value
        end
      end

      if attributes.key?(:'created_referrals')
        if (value = attributes[:'created_referrals']).is_a?(Array)
          self.created_referrals = value
        end
      end

      if attributes.key?(:'awarded_giveaways')
        if (value = attributes[:'awarded_giveaways']).is_a?(Array)
          self.awarded_giveaways = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @effects.nil?
        invalid_properties.push('invalid value for "effects", effects cannot be nil.')
      end

      if @created_coupons.nil?
        invalid_properties.push('invalid value for "created_coupons", created_coupons cannot be nil.')
      end

      if @created_referrals.nil?
        invalid_properties.push('invalid value for "created_referrals", created_referrals cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @effects.nil?
      return false if @created_coupons.nil?
      return false if @created_referrals.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          customer_session == o.customer_session &&
          customer_profile == o.customer_profile &&
          event == o.event &&
          loyalty == o.loyalty &&
          referral == o.referral &&
          coupons == o.coupons &&
          triggered_campaigns == o.triggered_campaigns &&
          effects == o.effects &&
          rule_failure_reasons == o.rule_failure_reasons &&
          created_coupons == o.created_coupons &&
          created_referrals == o.created_referrals &&
          awarded_giveaways == o.awarded_giveaways
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [customer_session, customer_profile, event, loyalty, referral, coupons, triggered_campaigns, effects, rule_failure_reasons, created_coupons, created_referrals, awarded_giveaways].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        TalonOne.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
