=begin
#Talon.One API

#The Talon.One API is used to manage applications and campaigns, as well as to integrate with your application. The operations in the _Integration API_ section are used to integrate with our platform, while the other operations are used to manage applications and campaigns.  ### Where is the API?  The API is available at the same hostname as these docs. For example, if you are reading this page at `https://mycompany.talon.one/docs/api/`, the URL for the [updateCustomerProfile][] operation is `https://mycompany.talon.one/v1/customer_profiles/id`  [updateCustomerProfile]: #operation--v1-customer_profiles--integrationId--put 

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module TalonOne
  # 
  class NewReferralsForMultipleAdvocates
    # Timestamp at which point the referral code becomes valid.
    attr_accessor :start_date

    # Expiry date of the referral code. Referral never expires if this is omitted, zero, or negative.
    attr_accessor :expiry_date

    # The number of times a referral code can be used. This can be set to 0 for no limit, but any campaign usage limits will still apply. 
    attr_accessor :usage_limit

    # The ID of the campaign from which the referral received the referral code.
    attr_accessor :campaign_id

    # An array containing all the respective advocate profiles.
    attr_accessor :advocate_profile_integration_ids

    # Arbitrary properties associated with this item.
    attr_accessor :attributes

    # Set of characters to be used when generating random part of code. Defaults to [A-Z, 0-9] (in terms of RegExp).
    attr_accessor :valid_characters

    # The pattern that will be used to generate referrals. The character `#` acts as a placeholder and will be replaced by a random character from the `validCharacters` set. 
    attr_accessor :referral_pattern

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'start_date' => :'startDate',
        :'expiry_date' => :'expiryDate',
        :'usage_limit' => :'usageLimit',
        :'campaign_id' => :'campaignId',
        :'advocate_profile_integration_ids' => :'advocateProfileIntegrationIds',
        :'attributes' => :'attributes',
        :'valid_characters' => :'validCharacters',
        :'referral_pattern' => :'referralPattern'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'start_date' => :'DateTime',
        :'expiry_date' => :'DateTime',
        :'usage_limit' => :'Integer',
        :'campaign_id' => :'Integer',
        :'advocate_profile_integration_ids' => :'Array<String>',
        :'attributes' => :'Object',
        :'valid_characters' => :'Array<String>',
        :'referral_pattern' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `TalonOne::NewReferralsForMultipleAdvocates` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `TalonOne::NewReferralsForMultipleAdvocates`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'start_date')
        self.start_date = attributes[:'start_date']
      end

      if attributes.key?(:'expiry_date')
        self.expiry_date = attributes[:'expiry_date']
      end

      if attributes.key?(:'usage_limit')
        self.usage_limit = attributes[:'usage_limit']
      end

      if attributes.key?(:'campaign_id')
        self.campaign_id = attributes[:'campaign_id']
      end

      if attributes.key?(:'advocate_profile_integration_ids')
        if (value = attributes[:'advocate_profile_integration_ids']).is_a?(Array)
          self.advocate_profile_integration_ids = value
        end
      end

      if attributes.key?(:'attributes')
        self.attributes = attributes[:'attributes']
      end

      if attributes.key?(:'valid_characters')
        if (value = attributes[:'valid_characters']).is_a?(Array)
          self.valid_characters = value
        end
      end

      if attributes.key?(:'referral_pattern')
        self.referral_pattern = attributes[:'referral_pattern']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @usage_limit.nil?
        invalid_properties.push('invalid value for "usage_limit", usage_limit cannot be nil.')
      end

      if @usage_limit > 999999
        invalid_properties.push('invalid value for "usage_limit", must be smaller than or equal to 999999.')
      end

      if @usage_limit < 0
        invalid_properties.push('invalid value for "usage_limit", must be greater than or equal to 0.')
      end

      if @campaign_id.nil?
        invalid_properties.push('invalid value for "campaign_id", campaign_id cannot be nil.')
      end

      if @advocate_profile_integration_ids.nil?
        invalid_properties.push('invalid value for "advocate_profile_integration_ids", advocate_profile_integration_ids cannot be nil.')
      end

      if !@referral_pattern.nil? && @referral_pattern.to_s.length > 100
        invalid_properties.push('invalid value for "referral_pattern", the character length must be smaller than or equal to 100.')
      end

      if !@referral_pattern.nil? && @referral_pattern.to_s.length < 3
        invalid_properties.push('invalid value for "referral_pattern", the character length must be great than or equal to 3.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @usage_limit.nil?
      return false if @usage_limit > 999999
      return false if @usage_limit < 0
      return false if @campaign_id.nil?
      return false if @advocate_profile_integration_ids.nil?
      return false if !@referral_pattern.nil? && @referral_pattern.to_s.length > 100
      return false if !@referral_pattern.nil? && @referral_pattern.to_s.length < 3
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] usage_limit Value to be assigned
    def usage_limit=(usage_limit)
      if usage_limit.nil?
        fail ArgumentError, 'usage_limit cannot be nil'
      end

      if usage_limit > 999999
        fail ArgumentError, 'invalid value for "usage_limit", must be smaller than or equal to 999999.'
      end

      if usage_limit < 0
        fail ArgumentError, 'invalid value for "usage_limit", must be greater than or equal to 0.'
      end

      @usage_limit = usage_limit
    end

    # Custom attribute writer method with validation
    # @param [Object] referral_pattern Value to be assigned
    def referral_pattern=(referral_pattern)
      if !referral_pattern.nil? && referral_pattern.to_s.length > 100
        fail ArgumentError, 'invalid value for "referral_pattern", the character length must be smaller than or equal to 100.'
      end

      if !referral_pattern.nil? && referral_pattern.to_s.length < 3
        fail ArgumentError, 'invalid value for "referral_pattern", the character length must be great than or equal to 3.'
      end

      @referral_pattern = referral_pattern
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          start_date == o.start_date &&
          expiry_date == o.expiry_date &&
          usage_limit == o.usage_limit &&
          campaign_id == o.campaign_id &&
          advocate_profile_integration_ids == o.advocate_profile_integration_ids &&
          attributes == o.attributes &&
          valid_characters == o.valid_characters &&
          referral_pattern == o.referral_pattern
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [start_date, expiry_date, usage_limit, campaign_id, advocate_profile_integration_ids, attributes, valid_characters, referral_pattern].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        TalonOne.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
